## dgit 6.11~bpo9+1

=== debian/changelog ===
dgit (6.11~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Sean Whitton <spwhitton@spwhitton.name>  Mon, 03 Sep 2018 21:28:42 -0700

dgit (6.11) unstable; urgency=medium

  * dgit-maint-debrebase(7): move and improve the section
    "Inspecting the history".  [Sean Whitton]
  * Makefile: Adjust scope of dgit(7) pod rule.
  * local-pod-man: developer script, obsoleteed by `make %.view': drop it.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 26 Aug 2018 14:59:32 +0100

dgit (6.10) unstable; urgency=medium

  git-debrebase bugfixes:
  * Patches in subdirectories: fix malfunctions.  Closes:#907202,#907206.
  * new-upstream changelog entry: Use debchange.  Closes:#905888.
  * Empty patch queues: Fix some malfunctions and infelicities.
  * convert-to-gbp: Actually base the result on the breakwater, not HEAD.

  dgit bugfixes:
  * *build*: Cope with new-style --build= specifications
  * Pass --no-source to sbuild (always).  Closes:#904966.
  * build: Squash $buildproductsdir.  Closes:#906786.

  dgit improvements for git-debrebase compatibility:
  * Do not try split brain git-debrebase make-patches.  Closes:#906908.
  * Do not abandon quilt fixup at git-debrebase split commits.
  * Check for git-debrebase with a history walker, not debrebase-last.
    This can avoids using dpkg-source --commit.  Closes:#907208.

  git-debrebase improvements:
  * convert-from-*: snag on discarding comments in series.  Closes:#907198.
  * forget-was-ever-debrebase: New subcommand.
  * Make all commit message annotations have a COMMIT-TYPE.

  git-debrebase documentation:
  * dgit-maint-debrebase(7): Add runes for inspecting.  Closes:#907190.
  * git-debrebase(5): Warn against renaming branch while unstitched
  * git-debrebase(5): Document new understanding of debrebase-last

  test suite behavioural changes for ad-hoc runs:
  * run-all: Without --progressive, rm and recreate tests/tmp
  * run-all: Honour DGIT_TESTS_TMPDIR
  * run-all: Understand `:' specially

  test suite:
  * Tests for the bugfixes and improvements.
  * lib-gdr: Be more defensive about unexpected states/args
  * lib-gdr: Check that we made patches with git-debrebase
  * Honour DGIT_TEST_RUN_PFX env var.
  * Test dgit calling git-debrebase on new debianisation.
  * gdr-new-upstream: Check changelog is exactly right.
  * debchange: Widespread better handling of the time seen by dch.
    Freeze time.  Work around faketime TZ bug (#907264).
  * test-list-uptodate: Drop imports and dependencies
  * git-debrebase: gdr-merge-conflicts: Call git merge --no-edit
  * build-modes-*: Provide stunt dpkg-deb to pass -Znone, for speed.
  * build-products-dir: Check nothing in ../
  * Work if $tmp is on a different filesystem.
  * Internal changes and refactoring to support other changes.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 26 Aug 2018 14:58:18 +0100

dgit (6.9) unstable; urgency=medium

  * dgit: do not crash on push of a new gdr package.  Closes:#906784.
  * dgit: Remove unsubstituted $changesfile from message  Closes:906787.
  * dgit-maint-debrebase(7): improve "Converting an existing package",
    and refer to "ILLEGAL OPERATIONS" in git-debrebase(5).
    Closes:#905573.  [ Sean Whitton ]
  * test suite: Update debian/tests/control following dependency fix.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Tue, 21 Aug 2018 14:36:36 +0100

dgit (6.8) unstable; urgency=medium

  * test suite: Fix dependencies of new gdr-merge-conflicts test.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Mon, 20 Aug 2018 14:52:03 +0100

dgit (6.7) unstable; urgency=medium

  git-debrebase, bugfixes:
  * make-patches: Do not bail if there aren't any.
  * scrap: works properly when it does only rebase --abort.
  * On rebase: always save ffq-prev even if we were both stitched and
    laundered.  Closes:#905975.

  git-debrebase, improvements:
  * Speed: improve laundry performance by a factor of ~55:1,
    and analysis performance by factor of ~4.2:1.  Closes:#905995.
  * prepush: this is now a silent no-op if the branch is
    unstitched.  This is more friendly.
  * convert-from-*: Snag on patches in d/patches which are not in series,
    because they will be deleted.  Closes:#904997.
  * Highly experimental merge resolution support, enabled only with
    special command line option.
  * Lots of internal changes to support merge, and other work.
  * convert-from-*: Check whether ffq-prev or debrebase-last indicate that
    we are already in gdr format.
  * convert-from-*: leave debrebase-last refs to hint to everyone that
    this is now a gdr branch.

  git-debrebase, improved messages:
  * Improve ffq head recording message.
  * Better (less copious by default) debug output.
  * convert-from-gbp: Improve messages.  Closes:#906641.
  * Provide hints for unprocessable commits, depending on the apparent
    branch ffq state, including possible suggestion to use convert-from-*.
    Closes:#905005.  Closes:#905279.

  dgit, improved messages:
  * Mention bad origs as possible cause of quilt fixup failure,
    in both dgit(7) and in error messages.  No longer suggest
    --quilt=smash or dpkg-source --commit in the error message.
    Closes:906196.
  * Do not suggest --quilt modes if quilt fixup "stopped at"
    a commit made by git-debrebase.  Closes:#906197.
  * Mention gitattributes as a potential problem in quilt linearisation
    failure, when appropriate.  Closes:#906199.

  dgit, documentation:
  * dgit(1): Encourage --overwrite rather than --overwrite=version.
  * Document that we do not suppress attributes which affect git-archive.
    This is related to #906199.

  test suite:
  * test suite: Set DEBFULLNAME
  * test suite: unset GIT_EDITOR, so it works if user has that set.

  Packaging:
  * changelog: Add close note for #905400 to changelog entry for 6.5.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Mon, 20 Aug 2018 02:30:06 +0100

dgit (6.6~bpo9+1) stretch-backports; urgency=medium



## dgit 6.11

=== Makefile ===
# dgit
# Integration between git and Debian-style archives
#
# Copyright (C)2013-2016 Ian Jackson
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

INSTALL=install
INSTALL_DIR=$(INSTALL) -d
INSTALL_PROGRAM=$(INSTALL) -m 755
INSTALL_DATA=$(INSTALL) -m 644

prefix?=/usr/local

bindir=$(prefix)/bin
mandir=$(prefix)/share/man
perldir=$(prefix)/share/perl5
man1dir=$(mandir)/man1
man5dir=$(mandir)/man5
man7dir=$(mandir)/man7
infraexamplesdir=$(prefix)/share/doc/dgit-infrastructure/examples
txtdocdir=$(prefix)/share/doc/dgit
absurddir=$(prefix)/share/dgit/absurd

PROGRAMS=dgit dgit-badcommit-fixup
MAN1PAGES=dgit.1

MAN7PAGES=dgit.7				\
	dgit-user.7 dgit-nmu-simple.7		\
	dgit-maint-native.7			\
	dgit-maint-merge.7 dgit-maint-gbp.7	\
	dgit-maint-debrebase.7                  \
	dgit-downstream-dsc.7			\
	dgit-sponsorship.7

TXTDOCS=README.dsc-import
PERLMODULES=Debian/Dgit.pm Debian/Dgit/ExitStatus.pm
ABSURDITIES=git

GDR_PROGRAMS=git-debrebase
GDR_PERLMODULES= \
	Debian/Dgit.pm \
	Debian/Dgit/GDR.pm \
	Debian/Dgit/ExitStatus.pm
GDR_MAN1PAGES=git-debrebase.1
GDR_MAN5PAGES=git-debrebase.5

INFRA_PROGRAMS=dgit-repos-server dgit-ssh-dispatch \
	dgit-repos-policy-debian dgit-repos-admin-debian \
	dgit-repos-policy-trusting dgit-mirror-rsync
INFRA_EXAMPLES=get-dm-txt ssh-wrap drs-cron-wrap get-suites
INFRA_PERLMODULES= \
	Debian/Dgit.pm \
	Debian/Dgit/Infra.pm \
	Debian/Dgit/Policy/Debian.pm

MANPAGES=$(MAN1PAGES) $(MAN5PAGES) $(MAN7PAGES) \
	$(GDR_MAN1PAGES) $(GDR_MAN5PAGES)

all:	$(MANPAGES) $(addprefix substituted/,$(PROGRAMS))

substituted/%:	%
	mkdir -p substituted
	perl -pe 's{\bundef\b}{'\''$(absurddir)'\''} if m/###substituted###/' \
		<$< >$@

install:	installdirs all
	$(INSTALL_PROGRAM) $(addprefix substituted/,$(PROGRAMS)) \
		$(DESTDIR)$(bindir)
	$(INSTALL_PROGRAM) $(addprefix absurd/,$(ABSURDITIES)) \
		$(DESTDIR)$(absurddir)
	$(INSTALL_DATA) $(MAN1PAGES) $(DESTDIR)$(man1dir)
	$(INSTALL_DATA) $(MAN7PAGES) $(DESTDIR)$(man7dir)
	$(INSTALL_DATA) $(TXTDOCS) $(DESTDIR)$(txtdocdir)
	set -e; for m in $(PERLMODULES); do \
		$(INSTALL_DATA) $$m $(DESTDIR)$(perldir)/$${m%/*}; \
	done

installdirs:
	$(INSTALL_DIR) $(DESTDIR)$(bindir) \
		$(DESTDIR)$(man1dir) $(DESTDIR)$(man5dir) \
		$(DESTDIR)$(man7dir) \
		$(DESTDIR)$(txtdocdir) $(DESTDIR)$(absurddir) \
		$(addprefix $(DESTDIR)$(perldir)/, $(dir $(PERLMODULES)))

install-gdr:	installdirs-gdr
	$(INSTALL_PROGRAM) $(GDR_PROGRAMS) $(DESTDIR)$(bindir)
	$(INSTALL_DATA) $(GDR_MAN1PAGES) $(DESTDIR)$(man1dir)
	$(INSTALL_DATA) $(GDR_MAN5PAGES) $(DESTDIR)$(man5dir)
	set -e; for m in $(GDR_PERLMODULES); do \
		$(INSTALL_DATA) $$m $(DESTDIR)$(perldir)/$${m%/*}; \
	done

install-infra:	installdirs-infra
	$(INSTALL_PROGRAM) $(addprefix infra/, $(INFRA_PROGRAMS)) \
		$(DESTDIR)$(bindir)
	$(INSTALL_PROGRAM) $(addprefix infra/, $(INFRA_EXAMPLES)) \
		$(DESTDIR)$(infraexamplesdir)
	set -e; for m in $(INFRA_PERLMODULES); do \
		$(INSTALL_DATA) $$m $(DESTDIR)$(perldir)/$${m%/*}; \
	done

installdirs-gdr:
	$(INSTALL_DIR) $(DESTDIR)$(bindir) \
		$(DESTDIR)$(man1dir) $(DESTDIR)$(man5dir) \
		$(addprefix $(DESTDIR)$(perldir)/, $(dir $(GDR_PERLMODULES)))

installdirs-infra:
	$(INSTALL_DIR) $(DESTDIR)$(bindir) $(DESTDIR)$(infraexamplesdir) \
		$(addprefix $(DESTDIR)$(perldir)/, $(dir $(INFRA_PERLMODULES)))

list-manpages:
	@echo $(MANPAGES)

check installcheck:

clean distclean mostlyclean maintainer-clean:
	rm -rf tests/tmp substituted
	set -e; for m in $(MANPAGES); do \
		test -e $$m.pod && rm -f $$m; \
	done

dgit%: dgit%.pod
	m=$@; pod2man --section=$${m##*.} --date="Debian Project" \
		--center="dgit" --name=$${m%.*} \
		$^ $@

git-debrebase.%: git-debrebase.%.pod
	pod2man --section=$* --date="Debian Project" --center="git-debrebase" \
		--name=$(subst .$*,,$@) \
		$^ $@

%.view:	%
	man -l $*

=== debian/control ===
Source: dgit
Section: devel
Priority: optional
Maintainer: Ian Jackson <ijackson@chiark.greenend.org.uk>
Standards-Version: 3.9.4.0
Build-Depends: debhelper (>= 9)
Testsuite: autopkgtest
Vcs-Git: git://git.chiark.greenend.org.uk/~ianmdlvl/dgit.git
Vcs-Browser: http://www.chiark.greenend.org.uk/ucgi/~ianmdlvl/git/dgit.git/

Package: dgit
Depends: perl, libwww-perl, libdpkg-perl, git-core, devscripts, dpkg-dev,
         ${misc:Depends}, git-buildpackage, liblist-moreutils-perl,
         coreutils (>= 8.23-1~),
         libdigest-sha-perl, dput, curl, apt,
         libjson-perl, ca-certificates,
         libtext-iconv-perl, libtext-glob-perl
Recommends: ssh-client
Suggests: sbuild | pbuilder | cowbuilder
Architecture: all
Description: git interoperability with the Debian archive
 dgit (with the associated infrastructure) makes it possible to
 treat the Debian archive as a git repository.
 .
 dgit push constructs uploads from git commits
 .
 dgit clone and dgit fetch construct git commits from uploads.

Package: git-debrebase
Depends: perl, git-core, libdpkg-perl, libfile-fnmatch-perl, devscripts,
         ${misc:Depends}
Recommends: dgit, git-buildpackage
Architecture: all
Description: rebasing git workflow tool for Debian packaging
 git-debrebase is a tool for representing in git, and manipulating,
 Debian packages based on upstream source code.

Package: dgit-infrastructure
Depends: ${misc:Depends}, perl, git-core, gpgv, chiark-utils-bin,
         libjson-perl, libdigest-sha-perl, libdbd-sqlite3-perl, sqlite3,
         libwww-perl, libdpkg-perl
Recommends: dgit
Architecture: all
Priority: extra
Description: dgit server backend infrastructure
 This package contains tools which are useful for setting up a dgit
 git repository server.  You probably want dgit, the client package,
 instead of dgit-infrastructure.

=== debian/tests/control ===
Tests: build-modes-gbp
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc, faketime, git-buildpackage

Tests: clone-reprepro downstream-gitless
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc, faketime, reprepro

Tests: dpkgsourceignores-docs
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc, faketime
Restrictions: x-dgit-intree-only

Tests: defdistro-dsd-clone-drs dsd-clone-drs
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc, faketime
Restrictions: x-dgit-intree-only x-dgit-git-only

Tests: gdr-merge-conflicts
Tests-Directory: tests/tests
Depends: chiark-utils-bin, faketime, git-debrebase, git-buildpackage, quilt

Tests: gdr-diverge-nmu gdr-diverge-nmu-dgit gdr-edits gdr-fresh gdr-import-dgit gdr-import-dgitview gdr-import-nostitch gdr-makepatches7 gdr-merge gdr-subcommands gdr-unprocessable gdr-unprocessable-hints
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc, faketime, git-debrebase, git-buildpackage

Tests: gdr-newupstream gdr-viagit
Tests-Directory: tests/tests
Depends: chiark-utils-bin, faketime, git-debrebase, git-buildpackage

Tests: gitattributes
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc, faketime, bsdgames, man-db, git-man

Tests: hint-testsuite-triggers
Tests-Directory: tests/tests
Depends: gnupg, patch, diffutils
Restrictions: hint-testsuite-triggers

Tests: manpages-format
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc, faketime, man-db, make, groff, git-debrebase

Tests: defdistro-mirror mirror mirror-debnewgit mirror-private
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc, faketime, rsync

Tests: build-modes-sbuild quilt-gbp-build-modes-sbuild
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc, faketime, sbuild
Restrictions: x-dgit-schroot-build

Tests: sbuild-gitish
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc, faketime, sbuild, man-db
Restrictions: x-dgit-schroot-build

Tests: spelling
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc, faketime
Restrictions: x-dgit-git-only

Tests: test-list-uptodate

## dgit 6.12

=== debian/changelog ===
dgit (6.12) unstable; urgency=medium

  * test suite: t-check-only-bpd: Check $tmp/.. not .. .  Fixes bogus
    failure in Ubuntu CI.  Thanks to Mattia Rizzolo for the report.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Fri, 28 Sep 2018 18:17:36 +0100

## dgit 7.0~bpo9+1

=== debian/changelog ===
dgit (7.0~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Sean Whitton <spwhitton@spwhitton.name>  Wed, 10 Oct 2018 08:40:11 -0700

dgit (7.0) unstable; urgency=medium

  Bugfixes:
  * dgit: Do not sometimes crash in quilt-fixup if git-debrebase
    is not installed.  Closes:#910221.
  * git-debrebase: new-upstream: Drop `sleep 2' (!)
  * git-debrebase: anchor: Print the anchor, not the breakwater tip (!)
  * Get rid of perl warning "Statement unlikely to be reached"
    (introduced in 7.0~pre1).
  * git-debrebase: merges: Make warnings of lossage less overblown

  i18n (translation):
  * Support message translation for git-debrebase.  (Re #904883.)
  * Support document translation.  Closes:#904883.
  * po: Rename `all-po' target to `pofiles'

  Error message improvements (prompted by i18n work)
  * Replaced `die' with `confess' in many unexpected syscall errors
    and internal error cases.
  * git-debrebase; Print a proper message for failure to opendir
    the bpd and for failure to chdir to the toplevel.

  Internal changes:
  * Minor refactoring to support translation.
  * i18n-diff-auditor: New script to support translation markup.

  Packaging:
  * Use dh_missing --fail-missing
  * Add missing build-dependency on xgettext

  Test suite:
  * gdr-makepatches7: Fixes to dgit/git-debrebase interaction
  * gdr-makepatches7: Test dgit with missing git-debrebase
  * Test that the binary packages can be built

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Thu, 04 Oct 2018 20:33:12 +0100

dgit (7.0~pre1) experimental; urgency=medium

  * i18n: Support messgae translation for the program dgit.
    (Working towards #904883.)

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Tue, 02 Oct 2018 13:20:24 +0100

## dgit 7.0

=== Makefile ===
--- 
+++ 
@@ -45,14 +45,18 @@
 	dgit-sponsorship.7
 
 TXTDOCS=README.dsc-import
-PERLMODULES=Debian/Dgit.pm Debian/Dgit/ExitStatus.pm
+PERLMODULES= \
+	Debian/Dgit.pm \
+	Debian/Dgit/ExitStatus.pm \
+	Debian/Dgit/I18n.pm
 ABSURDITIES=git
 
 GDR_PROGRAMS=git-debrebase
 GDR_PERLMODULES= \
 	Debian/Dgit.pm \
 	Debian/Dgit/GDR.pm \
-	Debian/Dgit/ExitStatus.pm
+	Debian/Dgit/ExitStatus.pm \
+	Debian/Dgit/I18n.pm
 GDR_MAN1PAGES=git-debrebase.1
 GDR_MAN5PAGES=git-debrebase.5
 
@@ -123,6 +127,10 @@
 list-manpages:
 	@echo $(MANPAGES)
 
+i18n i18n-update:
+	$(MAKE) -C po update
+	$(MAKE) -C po4a update
+
 check installcheck:
 
 clean distclean mostlyclean maintainer-clean:

=== po4a/Makefile ===
# dgit document translation machinery
#
# Translators: there is no need to look at this file.  It contains
# complicated machinery which you do not need to understand :-).
# See po/README instead.

# Copyright (C)2018 Ian Jackson
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# ----- devel docs (translators, pleaee ignore all this) -----
#
# We use po4a for everything.
#
# po4a is nicely automatic for all the po handling, and the config
# file makes nice documentation, but it really really likes to dirty
# the tree.  And we want to automatically list the documents and the
# translation languages which it doesn't make easy.
#
# The approach I have chosen is as follows:
#
# po4a.cfg
#
#   This is autogenerated.  But also, we invite translators to add
#   their own language to it.  The resulting merge
#   conflict/discrepancy will be just an alphabetical ordering
#   discrepancy, since our generation script scans the available po
#   files.
#
#   Generation is done by a shell script, ./list-documents.
#
#   make targets:  po4a.cfg           # many others imply this
#                  po4a.cfg.check     # fails if out of date
#
# *.pot, *.po
#
#   As far as translators are concerned, generated and maintained by
#   po4a and committed to git.  As for the developers, we update this
#   occasionally just by running po4a.
#
#   make targets:  default           } mean
#                  pofiles           }  the same
#
# Translations for translators:
#
#   make targets:  preview.LANG
#                  translated
#
# Translated document source-language files (eg, translated pod):
#
#   Like with normal po things, the tools don't like to generate
#   output without updating (dirtying) the .po files.  But with po4a
#   this is really hard to avoid.  So we use a linkfarming technique.
#
#   make targets:  translated-only
#
# Translated output files (roff format, from pod2man):
#
#   We have sort of lost the usual make rule information by now
#   about targets and what to build.  Only po4a knows which
#   translated files are supposed to exist.  So we have a shell
#   script which reuses the top-level Makefile to run pod2man
#   where appropriate, and generate a further even-more-output-ish
#   tree.
#
#   make targets:  install


default: pofiles

include ../i18n-common.make
PO4A ?= po4a

all update: translated

pofiles: po4a.cfg
	$(PO4A) --no-translations $<

translated: po4a.cfg
	$(PO4A) $<

po4a.cfg: list-documents
	./$< $o

po4a.cfg.check: list-documents
	./$< >$@.tmp
	diff po4a.cfg $@.tmp

t = ../.po4a.translated-only
p = ../po4a

translated-only: po4a.cfg
	rm -rf $t && mkdir $t
	cd $t && ln -s $p/*.po $p/*.pot $p/po4a.cfg .
	cd $t && $(PO4A) po4a.cfg
	! test -d $t/translated || \
	cp -al --remove-destination $t/translated .

.po4a.%.cfg: po4a.cfg Makefile
	$S perl -p -e 's{^(\[po4a_langs\]).*}{$$1 $*};' \
		-e 's{:translated/man}{:.$*.translated/man}' \
		$< $o

.PRECIOUS: .po4a.%.cfg

preview.%: .po4a.%.cfg
	$S $(PO4A) $<
	$S ./install-documents >/dev/null .$*.translated $@
	@ echo '# runes to preview the various final tranlated manpages:'
	$S find $@ -type f -printf 'man -l %p\n'

# We can't really use timestamps to drive po4a
.PHONY: preview.% translated

install: translated-only
	./install-documents translated $(DESTDIR)

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Ian Jackson <ijackson@chiark.greenend.org.uk>
 Standards-Version: 3.9.4.0
-Build-Depends: debhelper (>= 9)
+Build-Depends: debhelper (>= 9), gettext, po4a
 Testsuite: autopkgtest
 Vcs-Git: git://git.chiark.greenend.org.uk/~ianmdlvl/dgit.git
 Vcs-Browser: http://www.chiark.greenend.org.uk/ucgi/~ianmdlvl/git/dgit.git/
@@ -11,6 +11,7 @@
 Package: dgit
 Depends: perl, libwww-perl, libdpkg-perl, git-core, devscripts, dpkg-dev,
          ${misc:Depends}, git-buildpackage, liblist-moreutils-perl,
+         liblocale-gettext-perl,
          coreutils (>= 8.23-1~),
          libdigest-sha-perl, dput, curl, apt,
          libjson-perl, ca-certificates,
@@ -28,6 +29,7 @@
 
 Package: git-debrebase
 Depends: perl, git-core, libdpkg-perl, libfile-fnmatch-perl, devscripts,
+         liblocale-gettext-perl,
          ${misc:Depends}
 Recommends: dgit, git-buildpackage
 Architecture: all
@@ -38,7 +40,8 @@
 Package: dgit-infrastructure
 Depends: ${misc:Depends}, perl, git-core, gpgv, chiark-utils-bin,
          libjson-perl, libdigest-sha-perl, libdbd-sqlite3-perl, sqlite3,
-         libwww-perl, libdpkg-perl
+         libwww-perl, libdpkg-perl,
+         liblocale-gettext-perl
 Recommends: dgit
 Architecture: all
 Priority: extra

=== debian/tests/control ===
--- 
+++ 
@@ -24,10 +24,6 @@
 Tests-Directory: tests/tests
 Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc, faketime, git-debrebase, git-buildpackage
 
-Tests: gdr-newupstream gdr-viagit
-Tests-Directory: tests/tests
-Depends: chiark-utils-bin, faketime, git-debrebase, git-buildpackage
-
 Tests: gitattributes
 Tests-Directory: tests/tests
 Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc, faketime, bsdgames, man-db, git-man
@@ -36,6 +32,10 @@
 Tests-Directory: tests/tests
 Depends: gnupg, patch, diffutils
 Restrictions: hint-testsuite-triggers
+
+Tests: gdr-newupstream gdr-viagit i18n-messages
+Tests-Directory: tests/tests
+Depends: chiark-utils-bin, faketime, git-debrebase, git-buildpackage
 
 Tests: manpages-format
 Tests-Directory: tests/tests
@@ -55,9 +55,6 @@
 Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc, faketime, sbuild, man-db
 Restrictions: x-dgit-schroot-build
 
-Tests: spelling
+Tests: i18n-po4a-uptodate package-build spelling
 Tests-Directory: tests/tests
 Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc, faketime
-Restrictions: x-dgit-git-only
-
-Tests: test-list-uptodate

## dgit 8.0~bpo9+1

=== debian/changelog ===
dgit (8.0~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Sean Whitton <spwhitton@spwhitton.name>  Sat, 20 Oct 2018 10:22:45 -0700

dgit (8.0) unstable; urgency=medium

  dgit - Behavioural change with compatibility implications:
  * Check (with --clean=dpkg-source[-d], ie, by default) that rules
    clean does not leave untracked files (ie, trip if it looks like
    a `git add' may have been forgotten).  dgit will now fail in
    some situations where previously it would have just carried on.
  * Honour new clean modes --dpkg-source[-d],no-check aka -wdn / -wddn
    which suppress this check.  (Whether the untracked files are
    used or disregarded depends on --include-dirty.)
  * Honour new .clean-mode-newer access config option, to allow git
    configs to be compatible with both new and old dgits.
    See relevant parts of dgit(1) for more information.

  dgit - Improved behaviours:
  * Better handling of cross-filesystem operations, including
    build-products-dir on a different fs.  Closes:#910730.
  * Change to git toplevel dir before starting.  Closes:#910724.
  * Provide --clean=check,ignores aka -wci.
  * Provide --clean=dpkg-source[-d],all-check aka -wda / -wdda.

  dgit - Important bugfixes:
  * Check that tree does not contain untracked files (depending on clean
    mode) when building source using git branch rather than using working
    tree.  In particular, honour --clean=check.  Closes:#910705.
  * Also apply that new cleanliness check during build-source or
    push-source etc. with --clean=dpkg-source; even though rules
    clean was not run.  See above.  Again, -wdn / -wddn may be needed.
  * dgit: Forbid source building with --include-dirty and non-.. bpd,
    which can seriously malfunction.  Closes:#910725; see #910740.

  dgit - Additional sanity checks:
  * quilt linearisation: Stop at debian/source/format changes.
  * quilt fixup: Cope if gdr analysis finds origin.  Closes:#910687.
  * Add missing error check in single-debian-patch handling.
  * Refuse to work if critical files have uncommitted changes.
  * Reject all git config options containing newlines.
  * Better error message for not in git tree.  (For git-debrebase too.)

  dgit - Minor bugfixes:
  * Fix spelling errors etc. in messages.
  * Replace mention of alioth by salsa in a message.
  * clean_tree: confess rather than die on unknown clean mode.
  * Add missing \n to crash from git_cat_file.  (git-debrebase too.)

  Documentation:
  * dgit(1): Document that cleaning is sometimes not needed and
    is therefore not done.
  * README.md: Add this document for the benefit of Salsa.
  * po/README: Mention -k10 threshold.
  * po/README: Give a pointer to salsa; remind the translator to commit.
  * dgit(1): Fix spelling errors.
  * dgit(7): Fix spelling errors.
  * dgit-sponsorship(7): Fix spelling error.

  Consequential changes:
  * Internal refactoring to support all these changes.
  * Tests adjusted to correspond to, and somewhat test, these changes.
  * Slight reorganisation to documentation of --clean=dpkg-source etc.

  Build system:
  * Makefile: Provide i18n-commit target.
  * po/list-documents: Set translation threshold to 10%.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sat, 13 Oct 2018 23:56:35 +0100

## dgit 8.1~bpo9+1

=== debian/changelog ===
dgit (8.1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Sean Whitton <spwhitton@spwhitton.name>  Sat, 17 Nov 2018 11:00:59 -0700

dgit (8.1) unstable; urgency=medium

  git-debrebase;
  * convert-from-unapplied: Provide aa an alias for convert-from-gbp
    and document its scope properly, etc.  Closes:#905433.
  * dgit-maint-debrebase(7): discuss -fdiverged with convert-from-*,
    and (prompted) dgit --overwrite.  Closes:#903377.  [Sean Whitton]

  i18n support:
  * Check pod translations for a common class of syntax error.
    (using new machinery for pairwise checking of pod translations.)
  * po4a: Add -LUTF-8 to the config.
  * po4a/.gitignore: actually ignore right .po4a.LANG.cfg.

  test suite:
  * Run everything with LC_CTYPE=C.UTF-8.
  * manpages-format: pass --warnings.
  * NOTES.podchecker: Document why we're not using podchecker.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Thu, 08 Nov 2018 02:09:05 +0000

## dgit 8.3~bpo9+1

=== debian/changelog ===
dgit (8.3~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Sean Whitton <spwhitton@spwhitton.name>  Fri, 11 Jan 2019 19:49:32 -0700

dgit (8.3) unstable; urgency=medium

  dgit - Behavioural changes with compatibility implications:
  * Pass --no-source-only-changes to pbuilder and cowbuilder
    Closes:#904862.  This option was only recently added to
    pbuilder.  For compatibility with old pbuilder, say, eg
    `dgit --pbuilder!:--no-source-only-changes'.
  * With --clean=git etc, check the tree is clean even before building
    source in dgit's private directory.  Specifically, with eg dgit sbuild
    or dgit build-source.  dgit prior to 6.0 would always clean the tree.
    dgit 6.0 to 8.1 would ignore untracked files completely, leading to
    occasional lossage.  The pre-6.0 behaviour can be requested with
    --clean=git,always etc. (aka -wga, -wgfa).  Closes:#914317.

  dgit - New features, bugfixes and improved behaviours:
  * Allow uppercase (ascii) letters in multi-orig components,
    as is allowed by the spec in dpkg-source(1).  Closes:#916926.
  * Honour --program!:option to suppress options passed by default.
  * clone: Create destination directory before using network.
  * Check early that build-products-dir is accessible.  Closes:#913648.
  * Look for origs in `..' as well as build-products-dir, and
    there are any, link them into the bpd.  Closes:#904878.
  * Provide new --git[-ff],always clean mode (as discussed above).

  i18n - new translations [Frans Spiesschaert]:
  * nl, dgit-user(7).   Closes:#918253.
  * nl, messages.   Closes:#917148.

  Documentation:
  * dgit(1): Fix documentation of .quilt-mode config.
  * dgit(1): Fix a formatting typo (spurious .TP).  Closes:#917194.
  * dgit-user(7): Fix formatting error in comment about multi-arch.
  * dgit-maint-debrebase(7): handle DFSG-filtering for a new package.
    [Sean Whitton]  Closes:#915973.

  Error message improvements:
  * dgit: When reporting no such package, say `source package'.
  * dgit: Fix reference to -wdn/-wddn in a message.
  * dgit: cleaning: Minorly improved handling of note about ignores.
  * dgit-repos-policy-debian: Remove duplicated text from force
    report message.  Closes:#913676.

  i18n infrastructure:
  * po/README: Fix reference to dgit-user_7.pot.
  * po4a, pairwise-pocheck: Fix recognition of bare `<...>'.
  * Update po and pot files.

  Internal changes;
  * dgit: Remove foolish uses of $b, which is very special in perl.
  * Modest refactoring to support the other changes.
  * test suite: pretend-pbuilder: Reject unknown options.
  * Test suite: examplegit setup: Do not leave the tree dirty.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Mon, 07 Jan 2019 00:14:05 +0000

## dgit 8.4

=== debian/changelog ===
dgit (8.4) unstable; urgency=medium

  Bugfixes:
  * dgit: import-dsc: Handle relative symlinks correctly.
    Closes:#913259.
  * dgit: Do not misrecognise some initial packaging as
    gdr-compatible.  Closes:#922446.  [Report from Sean Whitton]
  * git-debrebase: convert-*: Fix two broken error messages.
    Closes:#922462.  [Report from Didier 'OdyX' Raboud]

  Documentation:
  * [nl] translations updated.  Closes:#921088.  [Frans Spiesschaert]
  * Many manpage typo fixes.  Closes:#918384.  [Paul Hardy]
  * dgit(1): Write the leading dash of an option as '\-'.
    Closes:#921965.  [Bjarni Ingi Gislason]

  Test suite:
  * dgit: import-dsc: New test for abs/rel dsc component links

  Internal changes:
  * dgit: cmd_import_dsc: comment on lack of is_orig_file check
  * git-debrebase: resolve_upstream_version: Return $used too

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Fri, 01 Mar 2019 21:53:40 +0000

## dgit 8.5~bpo9+1

=== debian/changelog ===
dgit (8.5~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Sean Whitton <spwhitton@spwhitton.name>  Sun, 23 Jun 2019 16:40:20 +0100

dgit (8.5) unstable; urgency=medium

  * Replace `confess $!' with `confess "$!"', to actually print errno
    when crashing.  Closes:#929549.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Mon, 27 May 2019 00:20:58 +0100

## dgit 8.5

=== Makefile ===
--- 
+++ 
@@ -131,6 +131,11 @@
 	$(MAKE) -C po update
 	$(MAKE) -C po4a update
 
+i18n-commit:
+	set -e; x=$$(git status --porcelain); set -x; test "x$$x" = x
+	$(MAKE) i18n-update
+	git commit -a -m 'i18n-commit - autogenerated'
+
 check installcheck:
 
 clean distclean mostlyclean maintainer-clean:

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Ian Jackson <ijackson@chiark.greenend.org.uk>
 Standards-Version: 3.9.4.0
-Build-Depends: debhelper (>= 9), gettext, po4a
+Build-Depends: debhelper (>= 9), gettext, po4a, tcl
 Testsuite: autopkgtest
 Vcs-Git: git://git.chiark.greenend.org.uk/~ianmdlvl/dgit.git
 Vcs-Browser: http://www.chiark.greenend.org.uk/ucgi/~ianmdlvl/git/dgit.git/

=== debian/rules ===
#!/usr/bin/make -f

# dgit
# Integration between git and Debian-style archives
#
# Copyright (C)2013-2016 Ian Jackson
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

export prefix=/usr

%:
	dh $@

override_dh_gencontrol:
	dh_gencontrol
	set -e; \
	 cd debian/dgit; \
	 v=$$(perl -ne 'print if s/^version:\s+//i' DEBIAN/control); \
	 perl -i -pe "s/UNRELEASED/$$v/g if m/###substituted###/" usr/bin/dgit

override_dh_auto_clean:
	dh_auto_clean
	make -C po clean

globalperl=/usr/share/perl5

override_dh_auto_install: specpkg_install_gdr specpkg_install_infra
	make install prefix=/usr DESTDIR=debian/dgit
	make -C po install prefix=/usr DESTDIR=../debian/tmp \
		SUPPRESS_PO_UPDATE=1 S=''
	make -C po4a install DESTDIR=../debian/tmp S=''

override_dh_missing:
	dh_missing --fail-missing

specpkg_install_gdr: p=git-debrebase
specpkg_install_gdr: pm=GDR

specpkg_install_infra: p=dgit-infrastructure
specpkg_install_infra: pm=Infra

specpkg_install_%: tok=$*
specpkg_install_%: specperl=/usr/share/dgit/$(tok)/perl5
specpkg_install_%:
	make install-$(tok) prefix=/usr DESTDIR=debian/$(p) perldir=$(specperl)
#	# Most of the Perl modules in this package live in
#	# $(specperl).  The exception is Debian::Dgit::Infra, which
#	# lives in $(globalperl) and adds $(specperl) to @INC.
	set -ex; \
	 base=debian/$(p); \
	 mod=Debian/Dgit/$(pm).pm; \
	 src=$${base}$(specperl)/$${mod}; \
	 dst=$${base}$(globalperl)/$${mod}; \
	 mkdir -p $${dst%/*}; \
	 mv -f $$src $$dst; \
	 perl -i -p -e 'next unless m/###substituted###/;' \
		-e 'next unless s/^# (?=unshift \@INC,)//;' \
		-e 'die unless s{q\{\S+\}}{q{$(specperl)}};' \
		 $$dst

debian/tests/control: tests/enumerate-tests debian/tests/control.in
	$< gencontrol >$@.new && mv -f $@.new $@

debian/tests/control: tests/lib-core tests/lib-restricts
debian/tests/control: tests/tests $(wildcard tests/tests/*[^~#])

## dgit 9.2~bpo10+1

=== Makefile ===
--- 
+++ 
@@ -60,6 +60,9 @@
 GDR_MAN1PAGES=git-debrebase.1
 GDR_MAN5PAGES=git-debrebase.5
 
+GDP_PROGRAMS=git-debpush
+GDP_MAN1PAGES=git-debpush.1
+
 INFRA_PROGRAMS=dgit-repos-server dgit-ssh-dispatch \
 	dgit-repos-policy-debian dgit-repos-admin-debian \
 	dgit-repos-policy-trusting dgit-mirror-rsync
@@ -70,7 +73,8 @@
 	Debian/Dgit/Policy/Debian.pm
 
 MANPAGES=$(MAN1PAGES) $(MAN5PAGES) $(MAN7PAGES) \
-	$(GDR_MAN1PAGES) $(GDR_MAN5PAGES)
+	$(GDR_MAN1PAGES) $(GDR_MAN5PAGES) \
+	$(GDP_MAN1PAGES)
 
 all:	$(MANPAGES) $(addprefix substituted/,$(PROGRAMS))
 
@@ -98,6 +102,10 @@
 		$(DESTDIR)$(txtdocdir) $(DESTDIR)$(absurddir) \
 		$(addprefix $(DESTDIR)$(perldir)/, $(dir $(PERLMODULES)))
 
+install-gdp:    installdirs-gdp
+	$(INSTALL_PROGRAM) $(GDP_PROGRAMS) $(DESTDIR)$(bindir)
+	$(INSTALL_DATA) $(GDP_MAN1PAGES) $(DESTDIR)$(man1dir)
+
 install-gdr:	installdirs-gdr
 	$(INSTALL_PROGRAM) $(GDR_PROGRAMS) $(DESTDIR)$(bindir)
 	$(INSTALL_DATA) $(GDR_MAN1PAGES) $(DESTDIR)$(man1dir)
@@ -114,6 +122,9 @@
 	set -e; for m in $(INFRA_PERLMODULES); do \
 		$(INSTALL_DATA) $$m $(DESTDIR)$(perldir)/$${m%/*}; \
 	done
+
+installdirs-gdp:
+	$(INSTALL_DIR) $(DESTDIR)$(bindir) $(DESTDIR)$(man1dir)
 
 installdirs-gdr:
 	$(INSTALL_DIR) $(DESTDIR)$(bindir) \
@@ -154,5 +165,10 @@
 		--name=$(subst .$*,,$@) \
 		$^ $@
 
+git-debpush.1: git-debpush.1.pod
+	pod2man --section=1 --date="Debian Project" --center="git-debpush" \
+		--name git-debpush \
+		$^ $@
+
 %.view:	%
 	man -l $*

=== debian/changelog ===
dgit (9.2~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Sean Whitton <spwhitton@spwhitton.name>  Wed, 17 Jul 2019 16:50:10 +0100

dgit (9.2) unstable; urgency=medium

  * No change upload to force rebuild on buildd.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Tue, 09 Jul 2019 22:01:25 +0100

dgit (9.1) unstable; urgency=medium

  New tools for a "git-push-to-upload" workflow [Ian Jackson & Sean Whitton]:
  * New script in a new binary package: git-debpush.
    The new binary package is small, but
    + git-debpush needs to be in src:dgit, because its test suite is the
      dgit test suite; however,
    + git-debpush is functionally and conceptually independent of dgit,
      so should not go into bin:dgit; in particular
    + git-debpush's dependencies are quite different to the other
      binary packages.
  * New dgit-infrastructure subcommand, tag2upload, to process tags made
    by git-debpush.
    Please see git-debpush(1) for a sketch of the workflow.

  dgit:
  * Allow the -p option to be used with various push modes.
  * Include dgit tag metadata in maintainer view tags.
    For consistency with, and use by, git-debpush.
  * Include quilt metadata in the archive/ (dgit view) tag.
  * rpush protocol: Version 6, which includes split brain information
    for maintainer view tags.  And, actually use newer version
    (was broken in 9.0, which would prefer to select 4 not 5).
  * Add some missing blank lines to tag messages.
  * Some other refactoring.

  Other documentation:
  * dgit(1): fix a reference in the description of --quilt=auto [Sean
    Whitton].

  Translations:
  * Do not translate tag subject lines, because these are parsed by
    dgit-repos-server.

  Test suite:
  * Test cases for new tools for "git-push-to-upload" workflow.
  * drs-git-ext: honour DGIT_DRS_MODE.
  * Provide a stunt sendmail and a stunt dgit.
  * Unset CDPATH in case caller has it set.
  * Some other refactoring.

  Administrivia:
  * Update d/copyright years to include 2019 [Sean Whitton].

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 07 Jul 2019 14:28:27 +0100

dgit (9.0) unstable; urgency=medium

  dgit - low-impact incompatible change:
  * Drop support for, and testing of, dgit versions which use old tag name
    (debian/V; now that is maintainer view and dgit is archive/debian/V).
    The new tags came in in dgit 2.0 in October 2016.  No version of dgit
    without them was in any Debian release.  We don't expect there are any
    sites using old servers which do not support the new format, or anyone
    using a dgit client older than 2.x who cannot upgrade.

  git-debrebase fixes [Niko Tyni]:
  * Fix `git-debrebase convert-from-dgit-view <upstream>', which
    would crash due to an argument parser bug.  Closes:#930214.
  * git-debrebase(1): typo fix.  Closes:#930215.

  dgit - new capabilities:
  * Support split view with native packages, and with all quilt modes.
    Now we distinguish "split view" (meaning separate dgit branch) from
    "splitting quilt modes" (eg --quilt-unapplied).
    [Prompted in part by enquiries from Sam Hartman]  Closes:#926640.
  * Support for bare debian/ directory (aka packaging-only) git branches
    Ie, --quilt=baredebian[+tarball].  [Thanks for info from Shengjing
    Zhu, and docs and UI contributions/review from Sean Whitton.]
    Closes:#903392.  Closes:#931253.

  dgit - bugfixes:
  * Fix --dgit-view-save option alias, which never worked.
    (--save-dgit-view worked, and still does, though.)
  * i18n: Do not translate import commit messages.

  dgit - other documentation improvements [Sean Whitton]:
  * Expand on description of --include-dirty.  New text may help
    user avoid unexpected file deletion.  Closes:#930922.
  * dgit-maint-*(7): Suggest --name-status --diff-filter.  Closes:#930956.
  * dgit-maint-*(7): Using untagged upstream commits.  Closes:#930964.

  dgit - minor consequences of these other changes:
  * Actually properly reject invalid quilt modes found in git config.
    (Previously they might be accepted and then cause malfunctions.)
  * Reject split brain quilt modes with single-debian-patch.
    (Previously this would malfunction; now we reject it.)
  * i18n: Add translator notes about ASCII art changes display.
  * Drop "dgit view: changes are required..." message.
  * Some other minor changes to quilt fixup error handling.
  * Changes to debugging output related to quilt modes and split view.
  * Introduce rpush protocol version 5.  Minimum version is now 4.
  * Considerable internal rearrangement of quilt fixup code.
  * Considerable test suite work including new tests.

  dgit test suite:
  * dgit-repos-policy-debian: Test taint removal.  Closes:#929249.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Tue, 02 Jul 2019 16:55:15 +0100

dgit (8.6~) UNRELEASED; urgency=medium

  * dgit: rpush: Work in splitting quilt modes, again.  Closes:#931213.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Tue, 02 Jul 2019 14:36:47 +0100

=== debian/control ===
--- 
+++ 
@@ -37,6 +37,19 @@
  git-debrebase is a tool for representing in git, and manipulating,
  Debian packages based on upstream source code.
 
+Package: git-debpush
+Depends: devscripts, git, gnupg, ${misc:Depends}
+Architecture: all
+Description: client script for git pushing to Debian-style archives
+ git-debpush is a script to create and push a specially formatted
+ signed git tag.  The metadata in the tag indicates that the tagged
+ commit should be pushed (or "uploaded") to a Debian-style archive.
+ .
+ Tags generated by this script can be read by an intermediary service,
+ which performs any conversion that's needed (such as producing and
+ signing a .dsc and .changes), and then uploads the result to the
+ Debian-style archive on your behalf.
+
 Package: dgit-infrastructure
 Depends: ${misc:Depends}, perl, git-core, gpgv, chiark-utils-bin,
          libjson-perl, libdigest-sha-perl, libdbd-sqlite3-perl, sqlite3,

=== debian/rules ===
--- 
+++ 
@@ -36,7 +36,9 @@
 
 globalperl=/usr/share/perl5
 
-override_dh_auto_install: specpkg_install_gdr specpkg_install_infra
+override_dh_auto_install: specpkg_install_gdp \
+ specpkg_install_gdr \
+ specpkg_install_infra
 	make install prefix=/usr DESTDIR=debian/dgit
 	make -C po install prefix=/usr DESTDIR=../debian/tmp \
 		SUPPRESS_PO_UPDATE=1 S=''
@@ -45,16 +47,27 @@
 override_dh_missing:
 	dh_missing --fail-missing
 
+specpkg_install_gdp: p=git-debpush
+
 specpkg_install_gdr: p=git-debrebase
 specpkg_install_gdr: pm=GDR
 
 specpkg_install_infra: p=dgit-infrastructure
 specpkg_install_infra: pm=Infra
 
+define specpkg_install_common
+	make install-$(tok) prefix=/usr DESTDIR=debian/$(p) perldir=$(specperl)
+endef
+
+specpkg_install_gdp: tok=gdp
+specpkg_install_gdp: specperl=/usr/share/dgit/gdp/perl5
+specpkg_install_gdp:
+	$(specpkg_install_common)
+
 specpkg_install_%: tok=$*
 specpkg_install_%: specperl=/usr/share/dgit/$(tok)/perl5
 specpkg_install_%:
-	make install-$(tok) prefix=/usr DESTDIR=debian/$(p) perldir=$(specperl)
+	$(specpkg_install_common)
 #	# Most of the Perl modules in this package live in
 #	# $(specperl).  The exception is Debian::Dgit::Infra, which
 #	# lives in $(globalperl) and adds $(specperl) to @INC.

=== debian/tests/control ===
--- 
+++ 
@@ -1,3 +1,7 @@
+Tests: baredebian-multitar baredebian-plusgit baredebian-push baredebian-tarball
+Tests-Directory: tests/tests
+Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc, faketime, quilt, git-debrebase, git-buildpackage, libdpkg-perl, libgit-wrapper-perl, liblist-compare-perl, libstring-shellquote-perl, libtry-tiny-perl
+
 Tests: build-modes-gbp
 Tests-Directory: tests/tests
 Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc, faketime, git-buildpackage
@@ -39,7 +43,7 @@
 
 Tests: manpages-format
 Tests-Directory: tests/tests
-Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc, faketime, man-db, make, groff, git-debrebase
+Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc, faketime, man-db, make, groff, git-debrebase, git-debpush
 
 Tests: defdistro-mirror mirror mirror-debnewgit mirror-private
 Tests-Directory: tests/tests
@@ -52,9 +56,3 @@
 
 Tests: sbuild-gitish
 Tests-Directory: tests/tests
-Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc, faketime, sbuild, man-db
-Restrictions: x-dgit-schroot-build
-
-Tests: i18n-po4a-uptodate package-build spelling
-Tests-Directory: tests/tests
-Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc, faketime
